#pragma once

#define DATA_DIR "../data"
#define OUT_DIR "./out"
#define MODEL_DIR "./models"

#ifdef __CUDACC__
#define NB_THREADS 1024
#define NB_THREADS_2D_X 32
#define NB_THREADS_2D_Y 32
#define NB_THREADS_3D_X 16
#define NB_THREADS_3D_Y 16
#define NB_THREADS_3D_Z 4
__device__ constexpr const size_t M = 5; //log2(NB_THREADS_2D_Y));
#endif

// Save state to avoid recalulation on restart
#define SAVE_STATE true
// Redo the state even if it's already saved
#define FORCE_REDO false
// Use GPU to greatly accelerate runtime
#define GPU_BOOSTED true
// Number of weak classifiers
// const size_t TS[] =  { 1 };
// const size_t TS[] =  { 1, 5, 10 };
const size_t TS[] =  { 1, 5, 10, 25, 50 };
// const size_t TS[] =  { 1, 5, 10, 25, 50, 100, 200, 300 };
// const size_t TS[] =  { 1, 5, 10, 25, 50, 100, 200, 300, 400, 500, 1000 };

// Enable verbose output (for debugging purposes)
#define __DEBUG false
// Debugging options
#if __DEBUG
#define IDX_INSPECT 4548
#define IDX_INSPECT_OFFSET 100
#endif
